import {Directive} from "../Directive"
import * as colors from "colors/safe"
import * as repl from 'repl'

export class ShellDirective extends Directive {
    protected options: any = {
        welcome: `powered by Extollo, © ${(new Date).getFullYear()} Garrett Mills\nAccess your application using the "app" global.`,
        prompt: `${colors.blue('(')}extollo${colors.blue(') ➤ ')}`,
    }

    protected repl?: repl.REPLServer

    getDescription(): string {
        return 'launch an interactive shell inside your application'
    }

    getKeywords(): string | string[] {
        return ['shell']
    }

    getHelpText(): string {
        return ''
    }

    async handle(): Promise<void> {
        const state: any = {
            app: this.app(),
            make: this.make,
            container: this.container,
        }

        await new Promise<void>(res => {
            console.log(this.options.welcome)
            this.repl = repl.start(this.options.prompt)
            Object.assign(this.repl.context, state)
            this.repl.on('exit', () => res())
        })
    }
}
